diff --git a/third_party/rust/regex-syntax/src/unicode_tables/mod.rs b/third_party/rust/regex-syntax/src/unicode_tables/mod.rs
new file mode 100644
index 000000000000..6c2e9e7736eb
--- /dev/null
+++ b/third_party/rust/regex-syntax/src/unicode_tables/mod.rs
@@ -0,0 +1,9 @@
+pub mod age;
+pub mod case_folding_simple;
+pub mod general_category;
+pub mod perl_word;
+pub mod property_bool;
+pub mod property_names;
+pub mod property_values;
+pub mod script_extension;
+pub mod script;
diff --git a/third_party/rust/regex/build.rs b/third_party/rust/regex/build.rs
new file mode 100644
index 000000000000..9440ab92d734
--- /dev/null
+++ b/third_party/rust/regex/build.rs
@@ -0,0 +1,86 @@
+use std::env;
+use std::ffi::OsString;
+use std::process::Command;
+
+fn main() {
+    let rustc = env::var_os("RUSTC").unwrap_or(OsString::from("rustc"));
+    let output = Command::new(&rustc)
+        .arg("--version")
+        .output()
+        .unwrap()
+        .stdout;
+    let version = String::from_utf8(output).unwrap();
+
+    enable_simd_optimizations(&version);
+}
+
+fn enable_simd_optimizations(version: &str) {
+    // We don't activate SIMD optimizations these if we've explicitly disabled
+    // them. Disabling auto optimizations is intended for use in tests, so that
+    // we can reliably test fallback implementations.
+    if env::var_os("CARGO_CFG_REGEX_DISABLE_AUTO_OPTIMIZATIONS").is_some() {
+        return;
+    }
+    let parsed = match Version::parse(&version) {
+        Ok(parsed) => parsed,
+        Err(err) => {
+            eprintln!("failed to parse `rustc --version`: {}", err);
+            return;
+        }
+    };
+    let minimum = Version { major: 1, minor: 27, patch: 0 };
+    if version.contains("nightly") || parsed >= minimum {
+        println!("cargo:rustc-cfg=regex_runtime_teddy_ssse3");
+        println!("cargo:rustc-cfg=regex_runtime_teddy_avx2");
+    }
+}
+
+#[derive(Clone, Copy, Debug, Eq, PartialEq, PartialOrd, Ord)]
+struct Version {
+    major: u32,
+    minor: u32,
+    patch: u32,
+}
+
+impl Version {
+    fn parse(mut s: &str) -> Result<Version, String> {
+        if !s.starts_with("rustc ") {
+            return Err(format!("unrecognized version string: {}", s));
+        }
+        s = &s["rustc ".len()..];
+
+        let parts: Vec<&str> = s.split(".").collect();
+        if parts.len() < 3 {
+            return Err(format!("not enough version parts: {:?}", parts));
+        }
+
+        let mut num = String::new();
+        for c in parts[0].chars() {
+            if !c.is_digit(10) {
+                break;
+            }
+            num.push(c);
+        }
+        let major = num.parse::<u32>().map_err(|e| e.to_string())?;
+
+        num.clear();
+        for c in parts[1].chars() {
+            if !c.is_digit(10) {
+                break;
+            }
+            num.push(c);
+        }
+        let minor = num.parse::<u32>().map_err(|e| e.to_string())?;
+
+        num.clear();
+        for c in parts[2].chars() {
+            if !c.is_digit(10) {
+                break;
+            }
+            num.push(c);
+        }
+        let patch = num.parse::<u32>().map_err(|e| e.to_string())?;
+
+        Ok(Version { major, minor, patch })
+    }
+}
diff --git a/third_party/rust/regex/ci/after_success.sh b/third_party/rust/regex/ci/after_success.sh
index 2cf60f16e59f..4e11477e70f4 100755
--- a/third_party/rust/regex/ci/after_success.sh
+++ b/third_party/rust/regex/ci/after_success.sh
@@ -6,25 +6,16 @@
 set -e
 
 if [ "$TRAVIS_RUST_VERSION" != "nightly" ] || [ "$TRAVIS_PULL_REQUEST" != "false" ] || [ "$TRAVIS_BRANCH" != "master" ]; then
   exit 0
 fi
 
 env
 
-# Build and upload docs.
-echo '<meta http-equiv=refresh content=0;url=regex/index.html>' > target/doc/index.html
-ve=$(mktemp -d)
-virtualenv "$ve"
-"$ve"/bin/pip install --upgrade pip
-"$ve"/bin/pip install ghp-import
-"$ve"/bin/ghp-import -n target/doc
-git push -qf https://${TOKEN}@github.com/${TRAVIS_REPO_SLUG}.git gh-pages
-
 # Install kcov.
 tmp=$(mktemp -d)
 pushd "$tmp"
 wget https://github.com/SimonKagstrom/kcov/archive/master.tar.gz
 tar zxf master.tar.gz
 mkdir kcov-master/build
 cd kcov-master/build
 cmake ..
diff --git a/third_party/rust/regex/ci/run-kcov b/third_party/rust/regex/ci/run-kcov
index 092123775d10..78f5b96b3a5b 100755
--- a/third_party/rust/regex/ci/run-kcov
+++ b/third_party/rust/regex/ci/run-kcov
@@ -9,45 +9,31 @@ tests=(
   backtrack_utf8bytes
   backtrack_bytes
   nfa
   nfa_utf8bytes
   nfa_bytes
   regex
 )
 tmpdir=$(mktemp -d)
-with_plugin=
 coveralls_id=
 
 while true; do
   case "$1" in
-    --with-plugin)
-      with_plugin=yes
-      shift
-      ;;
     --coveralls-id)
       coveralls_id="$2"
       shift 2
       ;;
     *)
       break
       ;;
   esac
 done
 
-if [ -n "$with_plugin" ]; then
-  cargo test --manifest-path regex_macros/Cargo.toml --no-run --verbose
-  kcov \
-    --verify \
-    --include-pattern '/regex/src/' \
-    "$tmpdir/plugin" \
-    $(ls -t ./regex_macros/target/debug/plugin-* | head -n1)
-fi
-
-cargo test --no-run --verbose --jobs 4
+cargo test --no-run --verbose --jobs 4 --features unstable
 for t in ${tests[@]}; do
   kcov \
     --verify \
     --include-pattern '/regex/src/' \
     "$tmpdir/$t" \
     $(find ./target/debug -executable -wholename "./target/debug/$t-*" | head -n1)
 done
 
diff --git a/third_party/rust/regex/ci/script.sh b/third_party/rust/regex/ci/script.sh
index 2b48aa5d7ff5..edc7ecaae4c8 100755
--- a/third_party/rust/regex/ci/script.sh
+++ b/third_party/rust/regex/ci/script.sh
@@ -1,35 +1,56 @@
 #!/bin/sh
 
 # This is the main CI script for testing the regex crate and its sub-crates.
 
-set -e
+set -ex
 
 # Builds the regex crate and runs tests.
 cargo build --verbose
 cargo doc --verbose
+
+# If we're testing on an older version of Rust, then only check that we
+# can build the crate. This is because the dev dependencies might be updated
+# more frequently, and therefore might require a newer version of Rust.
+#
+# This isn't ideal. It's a compromise.
+if [ "$TRAVIS_RUST_VERSION" = "1.20.0" ]; then
+  exit
+fi
+
+# Run tests. If we have nightly, then enable our nightly features.
+# Right now there are no nightly features, but that may change in the
+# future.
+CARGO_TEST_EXTRA_FLAGS=""
 if [ "$TRAVIS_RUST_VERSION" = "nightly" ]; then
-  cargo build --verbose --manifest-path regex-debug/Cargo.toml
-  RUSTFLAGS="-C target-feature=+ssse3" cargo test --verbose --features 'simd-accel pattern' --jobs 4
-else
-  cargo test --verbose --jobs 4
+  CARGO_TEST_EXTRA_FLAGS=""
 fi
+cargo test --verbose ${CARGO_TEST_EXTRA_FLAGS}
+
+# Run the random tests in release mode, as this is faster.
+RUST_REGEX_RANDOM_TEST=1 \
+    cargo test --release --verbose \
+    ${CARGO_TEST_EXTRA_FLAGS} --test crates-regex
 
 # Run a test that confirms the shootout benchmarks are correct.
 ci/run-shootout-test
 
 # Run tests on regex-syntax crate.
 cargo test --verbose --manifest-path regex-syntax/Cargo.toml
 cargo doc --verbose --manifest-path regex-syntax/Cargo.toml
 
 # Run tests on regex-capi crate.
-cargo build --verbose --manifest-path regex-capi/Cargo.toml
-(cd regex-capi/ctest && ./compile && LD_LIBRARY_PATH=../target/debug ./test)
-(cd regex-capi/examples && ./compile && LD_LIBRARY_PATH=../target/debug ./iter)
+ci/test-regex-capi
 
 # Make sure benchmarks compile. Don't run them though because they take a
-# very long time.
+# very long time. Also, check that we can build the regex-debug tool.
 if [ "$TRAVIS_RUST_VERSION" = "nightly" ]; then
+  cargo build --verbose --manifest-path regex-debug/Cargo.toml
   for x in rust rust-bytes pcre1 onig; do
-    (cd bench && ./run $x --no-run)
+    (cd bench && ./run $x --no-run --verbose)
   done
+
+  # Test minimal versions.
+  cargo +nightly generate-lockfile -Z minimal-versions
+  cargo build --verbose
+  cargo test --verbose
 fi
diff --git a/third_party/rust/regex/ci/test-regex-capi b/third_party/rust/regex/ci/test-regex-capi
new file mode 100755
index 000000000000..f643aad0dde7
--- /dev/null
+++ b/third_party/rust/regex/ci/test-regex-capi
@@ -0,0 +1,7 @@
+#!/bin/sh
+
+set -e
+
+cargo build --verbose --manifest-path regex-capi/Cargo.toml
+(cd regex-capi/ctest && ./compile && LD_LIBRARY_PATH=../../target/debug ./test)
+(cd regex-capi/examples && ./compile && LD_LIBRARY_PATH=../../target/debug ./iter)
diff --git a/third_party/rust/regex/examples/shootout-regex-dna-bytes.rs b/third_party/rust/regex/examples/shootout-regex-dna-bytes.rs
index ec57157c8ea4..4010324db742 100644
--- a/third_party/rust/regex/examples/shootout-regex-dna-bytes.rs
+++ b/third_party/rust/regex/examples/shootout-regex-dna-bytes.rs
@@ -50,17 +50,17 @@ fn main() {
         (regex!("N"), &b"(a|c|g|t)"[..]),
         (regex!("R"), &b"(a|g)"[..]),
         (regex!("S"), &b"(c|g)"[..]),
         (regex!("V"), &b"(a|c|g)"[..]),
         (regex!("W"), &b"(a|t)"[..]),
         (regex!("Y"), &b"(c|t)"[..]),
     ];
     let mut seq = seq;
-    for (re, replacement) in substs.into_iter() {
+    for (re, replacement) in substs {
         seq = re.replace_all(&seq, replacement).into_owned();
     }
 
     for (variant, count) in counts {
         println!("{} {}", variant, count.join().unwrap());
     }
     println!("\n{}\n{}\n{}", ilen, clen, seq.len());
 }
diff --git a/third_party/rust/regex/examples/shootout-regex-dna-single.rs b/third_party/rust/regex/examples/shootout-regex-dna-single.rs
index a84bc63c1246..ed48b8b01083 100644
--- a/third_party/rust/regex/examples/shootout-regex-dna-single.rs
+++ b/third_party/rust/regex/examples/shootout-regex-dna-single.rs
@@ -43,13 +43,13 @@ fn main() {
         (regex!("N"), "(a|c|g|t)"),
         (regex!("R"), "(a|g)"),
         (regex!("S"), "(c|g)"),
         (regex!("V"), "(a|c|g)"),
         (regex!("W"), "(a|t)"),
         (regex!("Y"), "(c|t)"),
     ];
     let mut seq = seq;
-    for (re, replacement) in substs.into_iter() {
+    for (re, replacement) in substs {
         seq = re.replace_all(&seq, replacement).into_owned();
     }
     println!("\n{}\n{}\n{}", ilen, clen, seq.len());
 }
diff --git a/third_party/rust/regex/examples/shootout-regex-dna.rs b/third_party/rust/regex/examples/shootout-regex-dna.rs
index ec0060d7f445..2171bb3eab54 100644
--- a/third_party/rust/regex/examples/shootout-regex-dna.rs
+++ b/third_party/rust/regex/examples/shootout-regex-dna.rs
@@ -50,17 +50,17 @@ fn main() {
         (regex!("N"), "(a|c|g|t)"),
         (regex!("R"), "(a|g)"),
         (regex!("S"), "(c|g)"),
         (regex!("V"), "(a|c|g)"),
         (regex!("W"), "(a|t)"),
         (regex!("Y"), "(c|t)"),
     ];
     let mut seq = seq;
-    for (re, replacement) in substs.into_iter() {
+    for (re, replacement) in substs {
         seq = re.replace_all(&seq, replacement).into_owned();
     }
 
     for (variant, count) in counts {
         println!("{} {}", variant, count.join().unwrap());
     }
     println!("\n{}\n{}\n{}", ilen, clen, seq.len());
 }
diff --git a/third_party/rust/regex/scripts/generate.py b/third_party/rust/regex/scripts/generate.py
new file mode 100755
index 000000000000..7dbd065add27
--- /dev/null
+++ b/third_party/rust/regex/scripts/generate.py
@@ -0,0 +1,45 @@
+#!/usr/bin/env python3
+
+# This uses `ucd-generate` to generate all of the internal tables.
+
+import argparse
+import os
+import subprocess
+import sys
+
+
+def eprint(*args, **kwargs):
+    kwargs['file'] = sys.stderr
+    print(*args, **kwargs)
+
+
+def main():
+    p = argparse.ArgumentParser()
+    p.add_argument('ucd', metavar='DIR', nargs=1)
+    args = p.parse_args()
+    ucd = args.ucd[0]
+
+    def generate(subcmd, *args, **kwargs):
+        subprocess.run(("ucd-generate", subcmd, ucd) + args, check=True, **kwargs)
+
+    def generate_file(path, subcmd, *args, filename=None, **kwargs):
+        if filename is None:
+            filename = subcmd.replace('-', '_') + ".rs"
+        eprint('-', filename)
+        with open(os.path.join(path, filename), "w") as f:
+            generate(subcmd, *args, stdout=f, **kwargs)
+
+    eprint('generating regex-syntax tables')
+    path = os.path.join("regex-syntax", "src", "unicode_tables")
+    generate_file(path, "age", "--chars")
+    generate_file(path, "case-folding-simple", "--chars", "--all-pairs")
+    generate_file(path, "general-category", "--chars", "--exclude", "surrogate")
+    generate_file(path, "perl-word", "--chars")
+    generate_file(path, "property-bool", "--chars")
+    generate_file(path, "property-names")
+    generate_file(path, "property-values", "--include", "gc,script,scx,age")
+    generate_file(path, "script", "--chars")
+    generate_file(path, "script-extension", "--chars")
+
+if __name__ == '__main__':
+    main()
diff --git a/third_party/rust/regex/src/backtrack.rs b/third_party/rust/regex/src/backtrack.rs
index 78bc39e93e07..6e71e2c2f376 100644
--- a/third_party/rust/regex/src/backtrack.rs
+++ b/third_party/rust/regex/src/backtrack.rs
@@ -95,17 +95,17 @@ impl<'a, 'm, 'r, 's, I: Input> Bounded<'a, 'm, 'r, 's, I> {
         prog: &'r Program,
         cache: &ProgramCache,
         matches: &'m mut [bool],
         slots: &'s mut [Slot],
         input: I,
         start: usize,
     ) -> bool {
         let mut cache = cache.borrow_mut();
-        let mut cache = &mut cache.backtrack;
+        let cache = &mut cache.backtrack;
         let start = input.at(start);
         let mut b = Bounded {
             prog: prog,
             input: input,
             matches: matches,
             slots: slots,
             m: cache,
         };
@@ -211,16 +211,19 @@ impl<'a, 'm, 'r, 's, I: Input> Bounded<'a, 'm, 'r, 's, I> {
 
     fn step(&mut self, mut ip: InstPtr, mut at: InputAt) -> bool {
         use prog::Inst::*;
         loop {
             // This loop is an optimization to avoid constantly pushing/popping
             // from the stack. Namely, if we're pushing a job only to run it
             // next, avoid the push and just mutate `ip` (and possibly `at`)
             // in place.
+            if self.has_visited(ip, at) {
+                return false;
+            }
             match self.prog[ip] {
                 Match(slot) => {
                     if slot < self.matches.len() {
                         self.matches[slot] = true;
                     }
                     return true;
                 }
                 Save(ref inst) => {
@@ -270,19 +273,16 @@ impl<'a, 'm, 'r, 's, I: Input> Bounded<'a, 'm, 'r, 's, I> {
                             ip = inst.goto;
                             at = self.input.at(at.next_pos());
                             continue;
                         }
                     }
                     return false;
                 }
             }
-            if self.has_visited(ip, at) {
-                return false;
-            }
         }
     }
 
     fn has_visited(&mut self, ip: InstPtr, at: InputAt) -> bool {
         let k = ip * (self.input.len() + 1) + at.pos();
         let k1 = k / BIT_SIZE;
         let k2 = usize_to_u32(1 << (k & (BIT_SIZE - 1)));
         if self.m.visited[k1] & k2 == 0 {
